#[doc = "Register `TR_CFG` reader"]
pub struct R(crate::R<TR_CFG_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<TR_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<TR_CFG_SPEC>> for R {
    fn from(reader: crate::R<TR_CFG_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `TR_CFG` writer"]
pub struct W(crate::W<TR_CFG_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<TR_CFG_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<TR_CFG_SPEC>> for W {
    fn from(writer: crate::W<TR_CFG_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `TR_MODE_CFG` reader - Trigger Mode Configuration?'0' : dsi_tr\\[i\\]
is tied to udb_tr_out\\[i\\]?'1' : dsi_tr\\[i\\]
is synchornized to clk_tr before being sourced to dsi_tr\\[i\\]"]
pub struct TR_MODE_CFG_R(crate::FieldReader<u32, u32>);
impl TR_MODE_CFG_R {
    pub(crate) fn new(bits: u32) -> Self {
        TR_MODE_CFG_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TR_MODE_CFG_R {
    type Target = crate::FieldReader<u32, u32>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TR_MODE_CFG` writer - Trigger Mode Configuration?'0' : dsi_tr\\[i\\]
is tied to udb_tr_out\\[i\\]?'1' : dsi_tr\\[i\\]
is synchornized to clk_tr before being sourced to dsi_tr\\[i\\]"]
pub struct TR_MODE_CFG_W<'a> {
    w: &'a mut W,
}
impl<'a> TR_MODE_CFG_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u32) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff_ffff) | (value as u32 & 0xffff_ffff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:31 - Trigger Mode Configuration?'0' : dsi_tr\\[i\\]
is tied to udb_tr_out\\[i\\]?'1' : dsi_tr\\[i\\]
is synchornized to clk_tr before being sourced to dsi_tr\\[i\\]"]
    #[inline(always)]
    pub fn tr_mode_cfg(&self) -> TR_MODE_CFG_R {
        TR_MODE_CFG_R::new((self.bits & 0xffff_ffff) as u32)
    }
}
impl W {
    #[doc = "Bits 0:31 - Trigger Mode Configuration?'0' : dsi_tr\\[i\\]
is tied to udb_tr_out\\[i\\]?'1' : dsi_tr\\[i\\]
is synchornized to clk_tr before being sourced to dsi_tr\\[i\\]"]
    #[inline(always)]
    pub fn tr_mode_cfg(&mut self) -> TR_MODE_CFG_W {
        TR_MODE_CFG_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Trigger Configuration\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [tr_cfg](index.html) module"]
pub struct TR_CFG_SPEC;
impl crate::RegisterSpec for TR_CFG_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [tr_cfg::R](R) reader structure"]
impl crate::Readable for TR_CFG_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [tr_cfg::W](W) writer structure"]
impl crate::Writable for TR_CFG_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets TR_CFG to value 0"]
impl crate::Resettable for TR_CFG_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
